<template>
  <div>
    <SearchResource
      :lab-item="true"
      @getSearchData="getAvailableResources"
    />
    <div class="tableDiv">
      <el-row>
        <el-col
          :span="24"
          class="table"
        >
          <el-table
            :data="currPageTableData"
            border
          >
            <el-table-column
              prop="ipAddress"
              :label="$t('env.ipAddress')"
            />
            <el-table-column
              prop="lab"
              :label="$t('env.lab')"
            />
            <el-table-column
              :label="$t('env.status')"
            >
              <template slot-scope="scope">
                <span
                  :style="getStatusColor(scope.row.status)"
                >
                  {{ $t(scope.row.status) }}
                </span>
              </template>
            </el-table-column>
            <el-table-column
              prop="specifications"
              :label="$t('env.specifications')"
            />
            <el-table-column
              prop="specialResources"
              :label="$t('env.specialResources')"
            />
            <el-table-column
              :label="$t('env.operation')"
              width="220"
            >
              <template slot-scope="scope">
                <el-button
                  id="editUsrBtn"
                  type="text"
                  size="small"
                  @click="applyResource(scope.row)"
                >
                  Apply
                </el-button>
              </template>
            </el-table-column>
          </el-table>
        </el-col>
      </el-row>
      <div class="pageBar">
        <Pagination
          :table-data="paginationData"
          @getCurrentPageData="getCurrentPageData"
        />
      </div>
    </div>
  </div>
</template>
<script>
import SearchResource from '../../components/SearchResource.vue'
import Pagination from '../../components/Pagination.vue'
import axios from 'axios'
import { BASE_URL } from '../../tools/constant.js'
export default {
  name: 'ResRequest',
  components: {
    SearchResource,
    Pagination
  },
  data () {
    return {
      getResDataList: [],
      paginationData: [],
      currPageTableData: []
    }
  },
  beforeMount () {
    this.getAvailableResources()
  },
  methods: {
    getStatusColor (status) {
      let statusColor = {}
      switch (status) {
        case 'Available':
          statusColor = { 'color': '#327ace' }
          break
        case 'Waiting':
          statusColor = { 'color': '#eeae5a' }
          break
        case 'Rejected':
          statusColor = { 'color': '#e82003' }
          break
        case 'Assigned':
        case 'Approved':
          statusColor = { 'color': '#3fa981' }
          break
      }
      return statusColor
    },
    getCurrentPageData (data) {
      this.currPageTableData = data
    },
    getAvailableResources () {
      let url = BASE_URL + '/getAvailableResources'
      axios({
        method: 'GET',
        url: url,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.paginationData = res.data
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    },
    applyResource (data) {
      data['userId'] = sessionStorage.getItem('userId')
      let url = BASE_URL + '/addResourceRequest'
      axios({
        method: 'POST',
        url: url,
        data: data,
        headers: {
          'Content-Type': 'application/json'
        }
      }).then(res => {
        this.$parent.$parent.successMessage(this.$t('confirm.resRequestSuccess'))
        this.$emit('cancelDialog', true)
      }, error => {
        if (error) {
          this.$parent.$parent.errorMessage(this.$t(error.response.data))
        }
      })
    }
  }
}
</script>
<style>
</style>
